



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>cocos2d-x(十二)Lua开发飞机大战-7-加入敌机</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">cocos2d-x(十二)Lua开发飞机大战-7-加入敌机</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 22:40:12 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<p>Lua本是一门面向过程的解释性语言。但在开发过程中有很多人还是习惯于面向对象编程。在Lua中我们能够使用table模拟类。只是写起来不太爽（特别是在继承一些C&#043;&#043;类的时候）。通过查看演示样例。发现cocos2d-x\samples\Lua\TestLua\Resources\luaScript路径下有一个“extern.lua”文件，这个文件封装对怎样创建一个类，而且十分easy继承C&#043;&#043;类。</p>
<p>这里仅仅介绍extern.lua的当中的两个方法，也是我们接下来要用到的两个方法。</p>
<p>1.function class(classname, super)&nbsp;&nbsp; 这种方法用于声明一个类，第一个參数是你要定义的类名，第二个參数要继承的父类实体（从參数中能够发现仅仅是实现单继承）。</p>
<p>2.function clone(Object) 这种方法用于复制对象</p>
<p>回到正题，想要增添敌机，第一件事想到肯定是定义一个敌机的实体类，那我们定义一个吧，在EnemyLayer.lua文件里定义Enemy实体类</p>
<pre class="prettyprint linenums">require &quot;Lua/extern&quot;<br />
Enemy = class(&quot;Enemy&quot;, function(frame)<br />
		local sprite = CCSprite:createWithSpriteFrameName(frame)<br />
		local peer = {}<br />
		tolua.setpeer(sprite,peer)<br />
		return sprite<br />
	end<br />
  )<br />
Enemy.__index = Enemy

function Enemy:create(frame,life,score,level)<br />
	local enemy = Enemy.new(frame)<br />
	local peer = tolua.getpeer(enemy)<br />
	peer.life = life--敌机的生命值<br />
	peer.score = score--打爆这架敌机，可获得的分数<br />
  	peer.level = level--敌机的等级，图片资源中有三种敌机<br />
	return enemy<br />
end

function Enemy:getLife()<br />
	return tolua.getpeer(self).life<br />
end

function Enemy:getLevel()<br />
	return tolua.getpeer(self).level<br />
end

function Enemy:getScore()<br />
	return tolua.getpeer(self).score<br />
end

function Enemy:loseLife()<br />
	tolua.getpeer(self).life = tolua.getpeer(self).life - 1<br />
end
</pre>
<p>有了敌机，我们再创建一个敌机图层</p>
<pre class="prettyprint linenums">function create()<br />
	layer = CCLayer:create()<br />
	start()<br />
	return layer<br />
end</pre>
<p>start()方法将全部敌机加入到图层中</p>
<pre class="prettyprint linenums">local enemyAEntry = nil<br />
local enemyBEntry = nil<br />
local enemyCEntry = nil<br />
function start()<br />
	enemyAEntry = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(addEnemyA, 3,false)<br />
	enemyBEntry = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(addEnemyB, 1,false)<br />
	enemyCEntry = CCDirector:sharedDirector():getScheduler():scheduleScriptFunc(addEnemyC, 10,false)<br />
end</pre>
<p>在这儿就仅仅贴出加入敌机A方法的代码addEnemyA()，其它两个都与这个类&#20284;。</p>
<pre class="prettyprint linenums">local Enemy_A_Life = 1<br />
local Enemy_B_Life = 2<br />
local Enemy_C_Life = 3

local Enemy_A_SCORE = 5<br />
local Enemy_B_SCORE = 10<br />
local Enemy_C_SCORE = 15

local Enemy_A_Level = 1<br />
local Enemy_B_Level = 2<br />
local Enemy_C_Level = 3

local layer = nil

local enemyArray = {}<br />
function addEnemyAB(frameName,life,score,level)

	local enemy = Enemy:create(frameName,life,score,level)<br />
	local enemyASizie = enemy:getContentSize()<br />
	local minX = enemyASizie.width / 2<br />
	local maxX = visibleSize.width - (enemyASizie.width / 2)<br />
	local rangX = maxX - minX<br />
	local actualX = (math.random() * rangX) + minX

	enemy:setPosition(ccp(actualX,visibleSize.height + enemyASizie.height / 2))<br />
	layer:addChild(enemy)<br />
	table.insert(enemyArray,enemy)

	local minDuration = 10<br />
	local maxDuration = 20<br />
	local rangeDur = maxDuration - minDuration<br />
	local actuakDur = (math.random() * rangeDur) + minDuration

	local actionMove = CCMoveTo:create(actuakDur,ccp(actualX,0 - enemy:getContentSize().height / 2))<br />
	local actionDone = CCCallFuncN:create(removeEnemy)<br />
	local sequence = CCSequence:createWithTwoActions(actionMove,actionDone)<br />
	enemy:runAction(sequence)

end

function addEnemyA()<br />
	addEnemyAB(&quot;enemy1.png&quot;,Enemy_A_Life,Enemy_A_SCORE,Enemy_A_Level)<br />
end
</pre>
<p>enemyArray这个參数用来存放全部的敌机，在后面的碰撞检測时会实用处。</p>
<p>本计划将代码整理后再上传，无赖这段时间太忙，没时间整理，也不知道什么时候有时间更新博文。</p>
<p>所以今天先将全部代码上传一份吧。方便大家学习交流。</p>
<p>源代码下载<a href="http://download.csdn.net/detail/yifuteli/7305869" rel="external nofollow noreferrer">http://download.csdn.net/detail/yifuteli/7305869</a></p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qy62e28.html">configure&colon; error&colon; &ast;&ast;&ast; libpopt not found 解决方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8ol55e8.html">LoRaWAN协议&lpar;五&rpar;--OTAA入网方式详述</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyoz028.html">VMware Fusion 中如何复制centos&sol;linux虚拟机</a>
		</li>
						<li><a href="https://www.batexi.com/a/jqd1gyvq.html">【T&lowbar;SQL】 基础</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qy301g8.html">VMware安装Linux第一天</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdew7vv9.html">Spark1&period;0源码编译</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7m7n1kq.html">Twitter注册</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyelgj9.html">MySQL - 主从复制及读写分离原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kplo059.html">借腾讯开源 VasDolly，谈谈 Android 签名和多渠道打包的原理！</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jnmjx8.html">动态规划算法的java实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj6p7l8.html">Python mac安装mysqlclient的一个bug</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1177lq.html">Java 学习笔记 反射与迭代器</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5kw57q.html">深入理解JVM&lpar;六&rpar;类文件结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w6jzwq.html">Apollo 3 定时&sol;长轮询拉取配置的设计</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy72exq.html">VC&lowbar;窗口exe&lowbar;printf信息</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxd1ygj9.html">python：OS模块</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko2616q.html">消息中间件（一）MQ详解及四大MQ比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql12x519.html">HDUOJ------1058 Humble Numbers</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppopg79.html">MySql登陆密码忘记了 怎么办？</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlomexkq.html">如何在非Spring管理的类中使用Spring加载的bean</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qv1v5xxq.html">RFS的web自动化验收测试&mdash;&mdash;第14讲 万能的evaluate</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo1g5vq.html">有N个正实数&lpar;注意是实数，大小升序排列&rpar; x1 &comma; x2 &period;&period;&period; xN，另有一个实数M。 需要选出若干个x，使这几个x的和与 M 最接近。 请描述实现算法，并指出算法复杂度</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy1dd12q.html">Java 异常解决之java&period;lang&period;IllegalArgumentException&colon; Comparison method violates its general contract&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90mvvpn8.html">【模式识别】Boosting</a>
			</li>
						<li><a href="https://www.batexi.com/a/93yxx6r8.html">Web端server推送技术原理分析及dwr框架简单的使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv1vvmoq.html">免插件打造wordpress投稿页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kp1p039.html">nginx使用自认证的https证书</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rgdgg78.html">【linux】linux根文件系统制作</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zo1od1q.html">Control&period;Invoke和Control&period;BeginInvoke</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj1drk8.html">underscore&period;js 源码</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
